import { source_distance } from "./source_distance.ts";
import { Property } from "./property.ts";
import { clang_format, log_from } from "./utils.ts";
export const log = log_from(import.meta);

export class Guess {
	property;
	value;

	constructor(property: Property, value: string) {
		this.property = property;
		this.value = value;
	}

	async test(source: string) {
		const original = source;
		const formatted = await clang_format(source, [this.property.name, this.value]);
		log("Scoring", this.property.name, ":", this.value);
		const distance = source_distance(original, formatted);
		const score = -1 * distance;
		log("Scored to", score);
		return score;
	}
}
